import React from "react";
import { TabLayoutGroupProperties } from "./../index";
import { TabLayoutGroupOrientation, TabLayoutGroupPosition } from './../index';
export { TabLayoutGroupProperties } from "./../index";
export { TabLayoutGroupOrientation, TabLayoutGroupPosition } from './../index';
declare let Smart: any;
export { Smart };
export interface TabLayoutGroupProps extends TabLayoutGroupProperties {
    className?: string;
    style?: React.CSSProperties;
    onCreate?: ((event?: Event) => void) | undefined;
    onReady?: ((event?: Event) => void) | undefined;
}
/**
 TabLayoutGroup represents a group of TabLayoutItems each with it's own Tab label.
*/
export declare class TabLayoutGroup extends React.Component<React.HTMLAttributes<Element> & TabLayoutGroupProps, any> {
    private _id;
    private nativeElement;
    private componentRef;
    get id(): string;
    /** Enables or disables the element.
    *	Property type: boolean
    */
    get disabled(): boolean;
    set disabled(value: boolean);
    /** Sets or gets the modifiers of the Layout item.
    *	Property type: any
    */
    get modifiers(): any;
    set modifiers(value: any);
    /** Determines the min size of the item.
    *	Property type: number
    */
    get min(): number;
    set min(value: number);
    /** Determines the label of the item.
    *	Property type: string
    */
    get label(): string;
    set label(value: string);
    /** Determines the group orientation.
    *	Property type: TabLayoutGroupOrientation | string
    */
    get orientation(): TabLayoutGroupOrientation | string;
    set orientation(value: TabLayoutGroupOrientation | string);
    /** Determines the position of the tab items group.
    *	Property type: TabLayoutGroupPosition | string
    */
    get position(): TabLayoutGroupPosition | string;
    set position(value: TabLayoutGroupPosition | string);
    /** Determines the size of the item.
    *	Property type: any
    */
    get size(): any;
    set size(value: any);
    /** If is set to true, the element cannot be focused.
    *	Property type: boolean
    */
    get unfocusable(): boolean;
    set unfocusable(value: boolean);
    get properties(): string[];
    /**  This event occurs, when the React component is created.
    *  @param event. The custom event. 	*/
    onCreate?: ((event?: Event) => void) | undefined;
    /**  This event occurs, when the React component is completely rendered.
    *  @param event. The custom event. 	*/
    onReady?: ((event?: Event) => void) | undefined;
    get eventListeners(): string[];
    constructor(props: any);
    componentDidRender(initialize: boolean): void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<{
        ref: any;
        suppressHydrationWarning: boolean;
    }, string | React.JSXElementConstructor<any>>;
}
export default TabLayoutGroup;
